//
//  ViewController.swift
//  buttonDemo
//
//  Created by zx on 1976/4/1.
//  Copyright © 2018年 zx. All rights reserved.
//

import UIKit
import WebKit

class ViewController: UIViewController,WKUIDelegate,WKNavigationDelegate {

    var webView : WKWebView!
//    var vi = UIView()
    override func loadView() {
        self.navigationItem.leftBarButtonItem = UIBarButtonItem(title: "返回", style: UIBarButtonItemStyle.plain, target: self, action: #selector(start))
        self.navigationController?.title = "首页"
        let conf = WKWebViewConfiguration()
        conf.userContentController = WKUserContentController()
        conf.preferences.javaScriptEnabled = true
        conf.selectionGranularity = WKSelectionGranularity.character
        conf.allowsInlineMediaPlayback = true
        //注册 js 消息通道
        conf.userContentController.add(self as WKScriptMessageHandler , name: "msgBridge")
        
        webView = WKWebView(frame: .zero, configuration: conf)  //.zero
        webView.uiDelegate = self
        //禁止顶部下拉 和 底部上拉效果
        //webView.scrollView.bounces = false
        //解决全屏播放视频 状态栏闪现导致的底部白条  never:表示不计算内边距
        //webView.scrollView.contentInsetAdjustmentBehavior = .never
        
        view = webView
    }
    @objc func start(){
        print("aaa")
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
//        setLayout()
//        let myURL = URL(string: "https://www.baidu.com")
//        let myRequest = URLRequest(url : myURL!)
//        webView.load(myRequest)
        
        /**加载 https 链接  **/
        //let myURL = URL(string: "http://192.168.2.186:8080")
        //let myRequest = URLRequest(url: myURL!)
        //webView.load(myRequest)
        
        /**加载本地 HTML文件**/
        //从主Bundle获取 HTML 文件的 url
//        let fileURL =  Bundle.main.url(forResource: "html/index", withExtension: "html" )
//        webView.loadFileURL(fileURL!,allowingReadAccessTo:Bundle.main.bundleURL);
        let bundlePath = Bundle.main.bundlePath
        
        let path = "file://\(bundlePath)/index.html"
        
        guard let url = URL(string: path) else {
            return
        }
        
        let request = URLRequest(url: url)
        
        webView.load(request)
        
        /**加载 html 内容**/
        //webView.loadHTMLString("<h1>h1</h1><img src='.html/images/h.png'>", baseURL: Bundle.main.bundleURL);
    }
    

//
//    func setLayout(){
//        let btn = UIButton(frame: CGRect(x: 20, y: UIApplication.shared.statusBarFrame.height, width: UIScreen.main.bounds.width-40, height: 40))
//        btn.setTitle("按钮", for: UIControlState.highlighted)
//        btn.setTitle("按钮", for: UIControlState.normal)
//        btn.backgroundColor = UIColor.green
//        btn.layer.cornerRadius = 15
//        btn.setTitleColor(UIColor.gray, for: UIControlState.normal)
//        btn.setTitleColor(UIColor.red, for: UIControlState.highlighted)
//        btn.setTitleShadowColor(UIColor.black, for: UIControlState.normal)
//        btn.setTitleShadowColor(UIColor.blue, for: UIControlState.highlighted)
//        btn.addTarget(self, action: #selector(listenfun(_:)), for: UIControlEvents.touchUpInside)
//        view.addSubview(btn)
//        vi = UIView(frame: CGRect(x: 20, y: 80, width: UIScreen.main.bounds.width-40, height: 40))
//        vi.backgroundColor = UIColor.green
//        vi.layer.cornerRadius = 15
//        vi.isUserInteractionEnabled = true
//        let tapGesture = UITapGestureRecognizer(target: self, action: #selector(ivewTouch))
//        tapGesture.numberOfTapsRequired = 1
//        tapGesture.addTarget(self, action: #selector(asdf(_ :)))
//        vi.addGestureRecognizer(tapGesture)
//        view.addSubview(vi)
//    }
//    @objc func asdf(_ tap : UITapGestureRecognizer){
//        print("12345678")
//    }
//    @objc func ivewTouch(){
//        UIView.animate(withDuration: 0.3, animations: {
//            self.vi.backgroundColor = UIColor.blue
//        }) { (true) in
//            self.vi.backgroundColor = UIColor.green
//        }
//       print("1234456789")
//    }
//    @objc func listenfun(_ button : UIButton){
//        UIView.animate(withDuration: 0.2, animations: {
//            button.backgroundColor = UIColor.blue
//        }) { (true) in
//            button.backgroundColor = UIColor.green
//        }
//    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

//js 和 swift 的交互
extension ViewController: WKScriptMessageHandler {
    
    //接收 js 发来的消息
    func userContentController(_ userContentController: WKUserContentController, didReceive message: WKScriptMessage) {
        
        //判断消息通道
        if(message.name == "msgBridge"){
            //TODO ...
            //message.body（any 类型） 即前端 js 传来的数据，如果传字符串这里接收的就是字符串，如果传 json 对象或 js 对象 则这里是 NSDictionary
            print(message.body)
            let msg = message.body as! NSDictionary;
            
            //swift 调 js函数
            webView.evaluateJavaScript("funcforswift('\( msg["msg"]  as! String)')", completionHandler: {
                (any, error) in
                if (error != nil) {
                    print(error ?? "err")
                }
            })
        }
        
    }
}
